def nms(boxes: Tensor,
    scores: Tensor,
    iou_threshold: float) -> Tensor:
  _0 = __torch__.torchvision.extension._assert_has_ops
  _1 = _0()
  _2 = ops.torchvision.nms(boxes, scores, iou_threshold)
  return _2
def batched_nms(boxes: Tensor,
    scores: Tensor,
    idxs: Tensor,
    iou_threshold: float) -> Tensor:
  _3 = __torch__.torchvision.ops.boxes._batched_nms_vanilla
  _4 = __torch__.torchvision.ops.boxes._batched_nms_coordinate_trick
  _5 = torch.numel(boxes)
  _6 = torch.eq(ops.prim.type(ops.prim.device(boxes)), "cpu")
  if _6:
    _7 = 4000
  else:
    _7 = 20000
  if torch.gt(_5, _7):
    _9 = torch.__not__(__torch__.torchvision._is_tracing())
    _8 = _9
  else:
    _8 = False
  if _8:
    _11 = _3(boxes, scores, idxs, iou_threshold, )
    _10 = _11
  else:
    _12 = _4(boxes, scores, idxs, iou_threshold, )
    _10 = _12
  return _10
def _batched_nms_vanilla(boxes: Tensor,
    scores: Tensor,
    idxs: Tensor,
    iou_threshold: float) -> Tensor:
  _13 = __torch__.torch.functional._return_output
  keep_mask = torch.zeros_like(scores, dtype=11)
  _14 = _13(idxs, True, False, False, None, )
  for _15 in range(torch.len(_14)):
    class_id = torch.select(_14, 0, _15)
    _16 = torch.where(torch.eq(idxs, class_id))
    curr_indices = _16[0]
    _17 = annotate(List[Optional[Tensor]], [curr_indices])
    _18 = torch.index(boxes, _17)
    _19 = annotate(List[Optional[Tensor]], [curr_indices])
    curr_keep_indices = __torch__.torchvision.ops.boxes.nms(_18, torch.index(scores, _19), iou_threshold, )
    _20 = annotate(List[Optional[Tensor]], [curr_keep_indices])
    _21 = torch.index(curr_indices, _20)
    _22 = torch.tensor(True, dtype=ops.prim.dtype(keep_mask), device=ops.prim.device(keep_mask))
    _23 = annotate(List[Optional[Tensor]], [_21])
    _24 = torch.index_put_(keep_mask, _23, _22)
  keep_indices = (torch.where(keep_mask))[0]
  _25 = annotate(List[Optional[Tensor]], [keep_indices])
  _26, _27 = torch.sort(torch.index(scores, _25), -1, True)
  _28 = annotate(List[Optional[Tensor]], [_27])
  return torch.index(keep_indices, _28)
def _batched_nms_coordinate_trick(boxes: Tensor,
    scores: Tensor,
    idxs: Tensor,
    iou_threshold: float) -> Tensor:
  if torch.eq(torch.numel(boxes), 0):
    _30 = ops.prim.device(boxes)
    _31 = torch.empty([0], dtype=4, layout=None, device=_30)
    _29 = _31
  else:
    max_coordinate = torch.max(boxes)
    _32 = torch.to(idxs, boxes)
    _33 = torch.add(max_coordinate, torch.to(torch.tensor(1), boxes))
    offsets = torch.mul(_32, _33)
    _34 = torch.unsqueeze(torch.slice(offsets), 1)
    boxes_for_nms = torch.add(boxes, _34)
    keep = __torch__.torchvision.ops.boxes.nms(boxes_for_nms, scores, iou_threshold, )
    _29 = keep
  return _29
